# Instructions for Logging Issues

## 1. Search for Duplicates

[Search the existing issues](https://github.com/pragmatismo-io/BotServer/issues) before logging a new one.

## 2. Do you have a question?

Please use the issue tracker for bugs and suggestions.
If you have a *question*, please use [Stack Overflow](https://stackoverflow.com/questions/tagged/botserver)

## 3. Did you find a bug?

We are not surprised, we're still in early preview so there are plenty of them right now.

When logging a bug, please be sure to include the following:
 * The platform you were using
 * If at all possible, an *isolated* way to reproduce the behavior
 * The behavior you expect to see, and the actual behavior

## 4. Do you have a suggestion?

We also accept suggestions in the issue tracker. 


In general, things we find useful when reviewing suggestions are:
* A description of the problem you're trying to solve
* An overview of the suggested solution
* Examples of how the suggestion would work in various places


# Instructions for Contributing Code

## Contributing bug fixes

General Bots is current in early preview. We're still accepting contributions in the form of bug fixes. 
A bug must have an issue tracking it in the issue tracker that has been approved by the Pragmatismo.io team. Your pull request should include a link to the bug that you are fixing. If you've submitted a PR for a bug, please post a comment in the bug to avoid duplication of effort.

## Contributing features

Please open an issue with the `Schema` label to get a discussion started.

## Legal

We appreciate community contributions to code repositories open sourced by Pragmatismo.io. By signing a contributor license agreement, we ensure that the community is free to use your contributions. 

## Housekeeping

Your pull request should: 

* Include a description of what your change intends to do
* Be a child commit of a reasonably recent commit in the **master** branch 
    * Requests need not be a single commit, but should be a linear sequence of commits (i.e. no merge commits in your PR)
* Have clear commit messages 
    * e.g. "Refactor feature", "Fix issue", "Add tests for issue"

## Running (and adding) the Tests

*Coming soon*
